// Responsive Breakpoints
$x-small-max: 599px;
$small-min: 600px;
$small-max: 959px;
$medium-min: 960px;
$medium-max: 1279px;
$large-min: 1280px;
$large-max: 1919px;
$x-large-min: 1920px;

// Elements size
$input-width-large: 60%;
$input-width-short: 15%;
$input-height: 38px;
$input-font-size: 1.5em;
$label-font-size-normal: 0.7em;
$cc-font-size-min: 1.0vw;
$cc-font-size: 1.3vw;
$cc-font-size-medium: 2vw;
$cc-font-size-big: 2vw;
$strip-font-size: 1.7em;
$label-line-height: 10px;

// Payment card layout
$card-width: 70%;
$card-height: 100px;

// Colours definition
$input-highlight: #333;
$input-focus-border-colour: #41acf4;
$input-border-color: #b2b2b2;
$wrapper-background: #fff;
$card-font-colour: #fff;
$card-font-invalid-colour: #ff5b5f;

// Misc
$wrapper-radius: 20px;
$small-padding: 1%;
$small-margin: 5%;
$medium-margin: 10%;
$big-margin: 20%;
$transition-time: 0.6s;
$small-radius: 3px;


.cc-form {
  align-items: center;
  display: flex;
  flex-flow: column;
  flex-wrap: wrap;
  height: 100%;
  justify-content: center;
  width: 100%;

  &--inline {
    align-items: inherit;
    display: inherit;
    flex-flow: row;
    flex-wrap: inherit;
    height: 100%;
    justify-content: flex-end;
    margin-bottom: $small-margin;
    width: 100%;

    // @include breakpoint(tablet) {
    //   align-items: inherit;
    //   display: inherit;
    //   flex-flow: row;
    //   flex-wrap: inherit;
    //   height: 100%;
    //   justify-content: flex-end;
    //   margin-bottom: $small-margin;
    //   width: 100%;
    // }

    // @include breakpoint(mobile) {
    //   align-items: center;
    //   display: inherit;
    //   flex-flow: column;
    //   flex-wrap: wrap;
    //   height: 100%;
    //   justify-content: center;
    //   width: 100%;
    // }
  }

  @at-root input {
    &[type='number'] {
      -moz-appearance: textfield;
    }

    &::-webkit-outer-spin-button,
    &::-webkit-inner-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  &__wrapper {
    // @include breakpoint(laptop) {
    //   margin-right: $small-margin;
    //   margin-top: $small-margin;

    //   &--long {
    //     width: $input-width-large;
    //   }

    //   &--short {
    //     width: $input-width-short;
    //   }

    //   &--last {
    //     margin-left: $small-margin;
    //     margin-right: $big-margin;
    //     margin-top: $label-line-height + 20px;
    //   }
    // }

  //   @include breakpoint(tablet) {
  //     margin-right: $small-margin;
  //     margin-top: $small-margin;

  //     &--long {
  //       width: $input-width-large;
  //     }

  //     &--short {
  //       width: $input-width-short;
  //     }

  //     &--last {
  //       margin-left: $small-margin;
  //       margin-right: $big-margin;
  //     }
  //   }

  //   @include breakpoint(mobile) {
  //     margin-right: 0;
  //     margin-top: 0;

  //     &--long,
  //     &--short {
  //       width: 80%;
  //     }

  //     &--last {
  //       margin-left: 0;
  //       margin-right: 0;
  //     }
  //   }
   }

  &__label {
    color: hsla(0, 0, 0, 0.6);
    display: block;
    font-family: 'Inconsolata', Serif, serif;
    font-size: $label-font-size-normal;
    font-weight: normal;
    letter-spacing: 1px;
    line-height: $label-line-height;
    margin-bottom: 5px;
    margin-top: $small-margin;
    text-align: left;
    text-shadow: none;
    text-transform: uppercase;
    width: 100%;

    &--first {
      margin-top: $big-margin;
    }
  }

  &__select {
    @extend .cc-form__input;
    appearance: listbox;
  }

  &__input {
    border: 1px solid hsla(0, 0, 0, 0.3);
    border-radius: 5px;
    box-shadow: inset 0 1px 4px hsla(0, 0, 0, 0.2);
    color: hsl(0, 0, 20);
    display: block;
    font-size: $input-font-size;
    height: $input-height;
    margin: 0;
    outline: none;
    padding: 0;
    text-align: left;
    width: 100%;

    &--transparent {
      background: transparent;
      border: none;
      border-radius: 0;
      box-shadow: none;
    }

    &--embosed {
      color: $card-font-colour;
      font-family: 'Inconsolata', monospace;
      font-size: $cc-font-size;
      text-shadow: 0 2px 1px hsla(0, 0, 0, 0.3);

      // @include breakpoint(tablet) {
      //   font-size: $cc-font-size-medium;
      // }

      // @include breakpoint(mobile) {
      //   font-size: $cc-font-size-big;
      // }
    }

    &--cursive {
      font-size: $label-font-size-normal;
      font-style: italic;
      left: 0;
      margin: 0 auto;
      position: absolute;
    }

    &--right-align {
      padding-right: $small-margin;
      text-align: right;
    }

    &--left-align {
      text-align: left;
    }

    &:focus {
      border-color: $input-focus-border-colour;
    }
  }

  &__error {
    color: $card-font-invalid-colour;
    font-size: $label-font-size-normal;
  }

  &__button {
    background: $input-focus-border-colour;
    border: 0;
    border-radius: $small-radius;
    color: $card-font-colour;
    cursor: pointer;
    margin-bottom: $small-margin;
    margin-top: $small-padding;
    outline: 0;
    overflow: hidden;
    padding: $small-padding;
    position: relative;
    text-align: center;
    user-select: none;
    vertical-align: middle;
    white-space: nowrap;
    width: $input-width-large;

    &:hover {
      box-shadow: 0 6px 8px -3px rgba(0, 0, 0, 0.3);
    }

    &:focus {
      background: darken($input-focus-border-colour, 12%);
    }

    &--ripple {
      overflow: hidden;
      position: relative;

      &:after {
        background: rgba(255, 255, 255, 0.3);
        border-radius: 80%;
        content: '';
        display: block;
        height: 120px;
        left: 50%;
        margin-left: -50%;
        margin-top: -60px;
        position: absolute;
        top: 50%;
        transform: scale(0);
        width: 100%;
      }

      &:not(:active):after {
        animation: button-ripple 2s ease-out;
      }
    }

    @keyframes button-ripple {
      0% {
        transform: scale(0);
      }
      20% {
        transform: scale(1);
      }
      100% {
        opacity: 0;
        transform: scale(1);
      }
    }
  }
}

.cc-wrapper {
  background-color: $wrapper-background;
  border-radius: $wrapper-radius;
  height: 100%;
  margin: 0;
  padding: 0;
  width: 100%;
}

.cc-box {
  height: $card-height;
  margin: 0 auto;
  padding: 0;
  position: relative;
  transform: translateY(-100%);
  width: $card-width;
  z-index: 1;

  // @include breakpoint(tablet) {
  //   transform: translateY(-115%);
  // }

  // @include breakpoint(mobile) {
  //   transform: translateY(-130%);
  // }

  &--flip {
    transform-style: preserve-3d;
    transition: $transition-time;

    &:hover,
    &.hover {
      transform: rotateY(180deg);
    }
  }

  &__element {
    padding: 0;
    width: 80%;
  }

  &__logo {
    align-items: center;
    color: $card-font-colour;
    display: flex;
    flex-flow: row nowrap;
    font-size: $cc-font-size-min;
    font-style: italic;
    font-weight: bold;
    justify-content: flex-end;
    margin-right: $medium-margin;
    width: 100%;
  }

  &__strip {
    background: linear-gradient(135deg, hsl(0, 0, 25%), hsl(0, 0, 10%));
    font-size: $strip-font-size;
    margin: 0;
    padding: 0;
    position: relative;
    transform: translateY(-90%);
    width: 100%;
  }

  &__front,
  &__back {
    align-items: center;
    backface-visibility: hidden;
    background: linear-gradient(135deg, #bd6772, #53223f);
    border-radius: 15px;
    display: flex;
    flex-direction: column;
    flex-flow: column nowrap;
    height: 250px;
    justify-content: center;
    left: 0;
    position: absolute;
    top: 0;
    width: 100%;
  }

  &__front {
    transform: rotateY(0deg);
  }

  &__back {
    transform: rotateY(180deg);
  }
}

.ng-invalid {
  &.ng-touched {
    border-color: $card-font-invalid-colour;
  }
}

.ng-valid {
  &.ng-touched {
    border-color: $input-border-color;
  }
}